<template>
  <div class="content-right-contentLeft">
    <div class="temperatureControl">
      <svg-icon iconClass="air_up" class="air_up"   @click="clickChange('up')" />

      <div class="temperatureControl-item-warpHidden"  
         @touchstart="onTouchStart"
         @touchmove="onTouchMove"
         @touchend="onTouchEnd"
      >
        <div class="temperatureControl-item-danwei">℃</div>

        <div
          class="temperatureControl-item-warp"
          :style="{ transform: `translateY(${$px2vw(moveOffset)})` }"
        >
          <div
            class="temperatureControl-item"
            v-for="(item, index) in numbers"
            :key="index"
            :class="currentIndex == index ? 'active' : ''"
          >
            {{ item }}
          </div>
        </div>
      </div>

      <svg-icon iconClass="air_down" class="air_down"  @click="clickChange('down')" />
    </div>

    <div class="content-right-name">{{ name }}</div>
  </div>
</template>
<script>
export default {
  props: {
    name: {
      type: String,
    },
  },
  data() {
    return {
      numbers: [
        "",
        "Hi",
        31,
        30,
        29,
        28,
        27,
        26,
        25,
        24,
        23,
        22,
        21,
        20,
        19,
        18,
        "Lo",
        "",
      ],
      moveOffset: -230,
      sliderOffset: 0,
      startY: 0,
      currentX: 0,
      endY:0,
      currentIndex: 11,
    };
  },
  methods: {
    onTouchStart(event) {
      this.startX = event.touches[0].pageX
    },
    onTouchMove(event) {
      const touch = event.touches[0]
      const offsetX = touch.pageX - this.startX
      this.currentX = this.sliderOffset + offsetX
    },
    onTouchEnd() {
      if (this.currentX < 30 && this.currentIndex > 0) {
        console.log(this.currentIndex, this.moveOffset)
        if (this.currentIndex <= 16 && this.currentIndex != 1) {
          this.moveOffset = this.moveOffset + 93
        }
        this.currentIndex = this.currentIndex == 1 ? 1 : this.currentIndex - 1
      } else if (this.currentX > -30 && this.currentIndex < 16) {
        console.log(this.currentIndex)
        if (this.currentIndex != 0 && this.currentIndex <= 15) {
          this.moveOffset = this.moveOffset - 93
        }
        this.currentIndex = this.currentIndex + 1
      }
      console.log(this.currentIndex)
      this.sliderOffset = 0
      this.currentX = this.sliderOffset
    },
     clickChange(data) {
      if (data == 'up' && this.currentIndex > 0) {
        console.log(this.currentIndex, this.moveOffset)
        if (this.currentIndex <= 16 && this.currentIndex != 1) {
          this.moveOffset = this.moveOffset + 93
        }
        this.currentIndex = this.currentIndex == 1 ? 1 : this.currentIndex - 1
      }
      else if (data == 'down' && this.currentIndex < 16) {
        console.log(this.currentIndex)
        if (this.currentIndex != 0 && this.currentIndex <= 15) {
          this.moveOffset = this.moveOffset - 93
        }
        this.currentIndex = this.currentIndex + 1
      }
      this.$emit('getTemperature', this.numbers[this.currentIndex])
      this.sliderOffset = 0
      this.currentX = this.sliderOffset
    },
  },
};
</script>
<style scoped lang="scss">
.content-right-contentLeft {
  height: 535px;
  width: 84px;
}
.content-right-name {
  position: absolute;
  bottom: 0;
  font-size: 26px;
  font-weight: 500;
  color: #393838;
  text-align: center;
  width: 100%;
}
.temperatureControl {
  position: relative;
  display: flex;
  flex-direction: column;
  align-items: center;

  padding-top: 67px;
  padding-bottom: 47px;
  .temperatureControl-item-warpHidden {
    display: flex;
    height: 300px;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    overflow: hidden;
    .temperatureControl-item-warp {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
    }
    .active {
      font-size: 74px;
      color: #3b3a3a;
    }
    .temperatureControl-item-danwei {
      font-size: 20px;
      position: absolute;
      right: -30px;
      margin-bottom: 30px;
    }
  }
  .temperatureControl-item {
    font-size: 40px;
    color: #9e9e9e;
    margin-bottom: 40px;
  }
  .air_up {
    top: 0px;
    position: absolute;
    width: 51.47px;
    height: 24.24px;
  }
  .air_down {
    bottom: 0;
    position: absolute;
    width: 51.47px;
    height: 22.47px;
  }
}
</style>
